procedure TileDecoder4(var PackedTile, DestTile);
var	Src		:	TPackedTile4 absolute PackedTile;
	Dest		:	TTile absolute DestTile;
begin
Dest[0, 0]	:= ((Src.Plane_0[0, 0] AND Bit7) SHR 7)		// line 0  pixel 0
		OR ((Src.Plane_0[0, 1] AND Bit7) SHR 6)
		OR ((Src.Plane_1[0, 0] AND Bit7) SHR 5)
		OR ((Src.Plane_1[0, 1] AND Bit7) SHR 4);
Dest[0, 1]	:= ((Src.Plane_0[0, 0] AND Bit6) SHR 6)		// line 0  pixel 1
		OR ((Src.Plane_0[0, 1] AND Bit6) SHR 5)
		OR ((Src.Plane_1[0, 0] AND Bit6) SHR 4)
		OR ((Src.Plane_1[0, 1] AND Bit6) SHR 3);
Dest[0, 2]	:= ((Src.Plane_0[0, 0] AND Bit5) SHR 5)		// line 0  pixel 2
		OR ((Src.Plane_0[0, 1] AND Bit5) SHR 4)
		OR ((Src.Plane_1[0, 0] AND Bit5) SHR 3)
		OR ((Src.Plane_1[0, 1] AND Bit5) SHR 2);
Dest[0, 3]	:= ((Src.Plane_0[0, 0] AND Bit4) SHR 4)		// line 0  pixel 3
		OR ((Src.Plane_0[0, 1] AND Bit4) SHR 3)
		OR ((Src.Plane_1[0, 0] AND Bit4) SHR 2)
		OR ((Src.Plane_1[0, 1] AND Bit4) SHR 1);
Dest[0, 4]	:= ((Src.Plane_0[0, 0] AND Bit3) SHR 3)		// line 0  pixel 4
		OR ((Src.Plane_0[0, 1] AND Bit3) SHR 2)
		OR ((Src.Plane_1[0, 0] AND Bit3) SHR 1)
		OR ((Src.Plane_1[0, 1] AND Bit3) SHR 0);
Dest[0, 5]	:= ((Src.Plane_0[0, 0] AND Bit2) SHR 2)		// line 0  pixel 5
		OR ((Src.Plane_0[0, 1] AND Bit2) SHR 1)
		OR ((Src.Plane_1[0, 0] AND Bit2) SHR 0)
		OR ((Src.Plane_1[0, 1] AND Bit2) SHL 1);
Dest[0, 6]	:= ((Src.Plane_0[0, 0] AND Bit1) SHR 1)		// line 0  pixel 6
		OR ((Src.Plane_0[0, 1] AND Bit1) SHR 0)
		OR ((Src.Plane_1[0, 0] AND Bit1) SHL 1)
		OR ((Src.Plane_1[0, 1] AND Bit1) SHL 2);
Dest[0, 7]	:= ((Src.Plane_0[0, 0] AND Bit0) SHR 0)		// line 0  pixel 7
		OR ((Src.Plane_0[0, 1] AND Bit0) SHL 1)
		OR ((Src.Plane_1[0, 0] AND Bit0) SHL 2)
		OR ((Src.Plane_1[0, 1] AND Bit0) SHL 3);

Dest[1, 0]	:= ((Src.Plane_0[1, 0] AND Bit7) SHR 7)		// line 1  pixel 0
		OR ((Src.Plane_0[1, 1] AND Bit7) SHR 6)
		OR ((Src.Plane_1[1, 0] AND Bit7) SHR 5)
		OR ((Src.Plane_1[1, 1] AND Bit7) SHR 4);
Dest[1, 1]	:= ((Src.Plane_0[1, 0] AND Bit6) SHR 6)		// line 1  pixel 1
		OR ((Src.Plane_0[1, 1] AND Bit6) SHR 5)
		OR ((Src.Plane_1[1, 0] AND Bit6) SHR 4)
		OR ((Src.Plane_1[1, 1] AND Bit6) SHR 3);
Dest[1, 2]	:= ((Src.Plane_0[1, 0] AND Bit5) SHR 5)		// line 1  pixel 2
		OR ((Src.Plane_0[1, 1] AND Bit5) SHR 4)
		OR ((Src.Plane_1[1, 0] AND Bit5) SHR 3)
		OR ((Src.Plane_1[1, 1] AND Bit5) SHR 2);
Dest[1, 3]	:= ((Src.Plane_0[1, 0] AND Bit4) SHR 4)		// line 1  pixel 3
		OR ((Src.Plane_0[1, 1] AND Bit4) SHR 3)
		OR ((Src.Plane_1[1, 0] AND Bit4) SHR 2)
		OR ((Src.Plane_1[1, 1] AND Bit4) SHR 1);
Dest[1, 4]	:= ((Src.Plane_0[1, 0] AND Bit3) SHR 3)		// line 1  pixel 4
		OR ((Src.Plane_0[1, 1] AND Bit3) SHR 2)
		OR ((Src.Plane_1[1, 0] AND Bit3) SHR 1)
		OR ((Src.Plane_1[1, 1] AND Bit3) SHR 0);
Dest[1, 5]	:= ((Src.Plane_0[1, 0] AND Bit2) SHR 2)		// line 1  pixel 5
		OR ((Src.Plane_0[1, 1] AND Bit2) SHR 1)
		OR ((Src.Plane_1[1, 0] AND Bit2) SHR 0)
		OR ((Src.Plane_1[1, 1] AND Bit2) SHL 1);
Dest[1, 6]	:= ((Src.Plane_0[1, 0] AND Bit1) SHR 1)		// line 1  pixel 6
		OR ((Src.Plane_0[1, 1] AND Bit1) SHR 0)
		OR ((Src.Plane_1[1, 0] AND Bit1) SHL 1)
		OR ((Src.Plane_1[1, 1] AND Bit1) SHL 2);
Dest[1, 7]	:= ((Src.Plane_0[1, 0] AND Bit0) SHR 0)		// line 1  pixel 7
		OR ((Src.Plane_0[1, 1] AND Bit0) SHL 1)
		OR ((Src.Plane_1[1, 0] AND Bit0) SHL 2)
		OR ((Src.Plane_1[1, 1] AND Bit0) SHL 3);

Dest[2, 0]	:= ((Src.Plane_0[2, 0] AND Bit7) SHR 7)		// line 2  pixel 0
		OR ((Src.Plane_0[2, 1] AND Bit7) SHR 6)
		OR ((Src.Plane_1[2, 0] AND Bit7) SHR 5)
		OR ((Src.Plane_1[2, 1] AND Bit7) SHR 4);
Dest[2, 1]	:= ((Src.Plane_0[2, 0] AND Bit6) SHR 6)		// line 2  pixel 1
		OR ((Src.Plane_0[2, 1] AND Bit6) SHR 5)
		OR ((Src.Plane_1[2, 0] AND Bit6) SHR 4)
		OR ((Src.Plane_1[2, 1] AND Bit6) SHR 3);
Dest[2, 2]	:= ((Src.Plane_0[2, 0] AND Bit5) SHR 5)		// line 2  pixel 2
		OR ((Src.Plane_0[2, 1] AND Bit5) SHR 4)
		OR ((Src.Plane_1[2, 0] AND Bit5) SHR 3)
		OR ((Src.Plane_1[2, 1] AND Bit5) SHR 2);
Dest[2, 3]	:= ((Src.Plane_0[2, 0] AND Bit4) SHR 4)		// line 2  pixel 3
		OR ((Src.Plane_0[2, 1] AND Bit4) SHR 3)
		OR ((Src.Plane_1[2, 0] AND Bit4) SHR 2)
		OR ((Src.Plane_1[2, 1] AND Bit4) SHR 1);
Dest[2, 4]	:= ((Src.Plane_0[2, 0] AND Bit3) SHR 3)		// line 2  pixel 4
		OR ((Src.Plane_0[2, 1] AND Bit3) SHR 2)
		OR ((Src.Plane_1[2, 0] AND Bit3) SHR 1)
		OR ((Src.Plane_1[2, 1] AND Bit3) SHR 0);
Dest[2, 5]	:= ((Src.Plane_0[2, 0] AND Bit2) SHR 2)		// line 2  pixel 5
		OR ((Src.Plane_0[2, 1] AND Bit2) SHR 1)
		OR ((Src.Plane_1[2, 0] AND Bit2) SHR 0)
		OR ((Src.Plane_1[2, 1] AND Bit2) SHL 1);
Dest[2, 6]	:= ((Src.Plane_0[2, 0] AND Bit1) SHR 1)		// line 2  pixel 6
		OR ((Src.Plane_0[2, 1] AND Bit1) SHR 0)
		OR ((Src.Plane_1[2, 0] AND Bit1) SHL 1)
		OR ((Src.Plane_1[2, 1] AND Bit1) SHL 2);
Dest[2, 7]	:= ((Src.Plane_0[2, 0] AND Bit0) SHR 0)		// line 2  pixel 7
		OR ((Src.Plane_0[2, 1] AND Bit0) SHL 1)
		OR ((Src.Plane_1[2, 0] AND Bit0) SHL 2)
		OR ((Src.Plane_1[2, 1] AND Bit0) SHL 3);

Dest[3, 0]	:= ((Src.Plane_0[3, 0] AND Bit7) SHR 7)		// line 3  pixel 0
		OR ((Src.Plane_0[3, 1] AND Bit7) SHR 6)
		OR ((Src.Plane_1[3, 0] AND Bit7) SHR 5)
		OR ((Src.Plane_1[3, 1] AND Bit7) SHR 4);
Dest[3, 1]	:= ((Src.Plane_0[3, 0] AND Bit6) SHR 6)		// line 3  pixel 1
		OR ((Src.Plane_0[3, 1] AND Bit6) SHR 5)
		OR ((Src.Plane_1[3, 0] AND Bit6) SHR 4)
		OR ((Src.Plane_1[3, 1] AND Bit6) SHR 3);
Dest[3, 2]	:= ((Src.Plane_0[3, 0] AND Bit5) SHR 5)		// line 3  pixel 2
		OR ((Src.Plane_0[3, 1] AND Bit5) SHR 4)
		OR ((Src.Plane_1[3, 0] AND Bit5) SHR 3)
		OR ((Src.Plane_1[3, 1] AND Bit5) SHR 2);
Dest[3, 3]	:= ((Src.Plane_0[3, 0] AND Bit4) SHR 4)		// line 3  pixel 3
		OR ((Src.Plane_0[3, 1] AND Bit4) SHR 3)
		OR ((Src.Plane_1[3, 0] AND Bit4) SHR 2)
		OR ((Src.Plane_1[3, 1] AND Bit4) SHR 1);
Dest[3, 4]	:= ((Src.Plane_0[3, 0] AND Bit3) SHR 3)		// line 3  pixel 4
		OR ((Src.Plane_0[3, 1] AND Bit3) SHR 2)
		OR ((Src.Plane_1[3, 0] AND Bit3) SHR 1)
		OR ((Src.Plane_1[3, 1] AND Bit3) SHR 0);
Dest[3, 5]	:= ((Src.Plane_0[3, 0] AND Bit2) SHR 2)		// line 3  pixel 5
		OR ((Src.Plane_0[3, 1] AND Bit2) SHR 1)
		OR ((Src.Plane_1[3, 0] AND Bit2) SHR 0)
		OR ((Src.Plane_1[3, 1] AND Bit2) SHL 1);
Dest[3, 6]	:= ((Src.Plane_0[3, 0] AND Bit1) SHR 1)		// line 3  pixel 6
		OR ((Src.Plane_0[3, 1] AND Bit1) SHR 0)
		OR ((Src.Plane_1[3, 0] AND Bit1) SHL 1)
		OR ((Src.Plane_1[3, 1] AND Bit1) SHL 2);
Dest[3, 7]	:= ((Src.Plane_0[3, 0] AND Bit0) SHR 0)		// line 3  pixel 7
		OR ((Src.Plane_0[3, 1] AND Bit0) SHL 1)
		OR ((Src.Plane_1[3, 0] AND Bit0) SHL 2)
		OR ((Src.Plane_1[3, 1] AND Bit0) SHL 3);

Dest[4, 0]	:= ((Src.Plane_0[4, 0] AND Bit7) SHR 7)		// line 4  pixel 0
		OR ((Src.Plane_0[4, 1] AND Bit7) SHR 6)
		OR ((Src.Plane_1[4, 0] AND Bit7) SHR 5)
		OR ((Src.Plane_1[4, 1] AND Bit7) SHR 4);
Dest[4, 1]	:= ((Src.Plane_0[4, 0] AND Bit6) SHR 6)		// line 4  pixel 1
		OR ((Src.Plane_0[4, 1] AND Bit6) SHR 5)
		OR ((Src.Plane_1[4, 0] AND Bit6) SHR 4)
		OR ((Src.Plane_1[4, 1] AND Bit6) SHR 3);
Dest[4, 2]	:= ((Src.Plane_0[4, 0] AND Bit5) SHR 5)		// line 4  pixel 2
		OR ((Src.Plane_0[4, 1] AND Bit5) SHR 4)
		OR ((Src.Plane_1[4, 0] AND Bit5) SHR 3)
		OR ((Src.Plane_1[4, 1] AND Bit5) SHR 2);
Dest[4, 3]	:= ((Src.Plane_0[4, 0] AND Bit4) SHR 4)		// line 4  pixel 3
		OR ((Src.Plane_0[4, 1] AND Bit4) SHR 3)
		OR ((Src.Plane_1[4, 0] AND Bit4) SHR 2)
		OR ((Src.Plane_1[4, 1] AND Bit4) SHR 1);
Dest[4, 4]	:= ((Src.Plane_0[4, 0] AND Bit3) SHR 3)		// line 4  pixel 4
		OR ((Src.Plane_0[4, 1] AND Bit3) SHR 2)
		OR ((Src.Plane_1[4, 0] AND Bit3) SHR 1)
		OR ((Src.Plane_1[4, 1] AND Bit3) SHR 0);
Dest[4, 5]	:= ((Src.Plane_0[4, 0] AND Bit2) SHR 2)		// line 4  pixel 5
		OR ((Src.Plane_0[4, 1] AND Bit2) SHR 1)
		OR ((Src.Plane_1[4, 0] AND Bit2) SHR 0)
		OR ((Src.Plane_1[4, 1] AND Bit2) SHL 1);
Dest[4, 6]	:= ((Src.Plane_0[4, 0] AND Bit1) SHR 1)		// line 4  pixel 6
		OR ((Src.Plane_0[4, 1] AND Bit1) SHR 0)
		OR ((Src.Plane_1[4, 0] AND Bit1) SHL 1)
		OR ((Src.Plane_1[4, 1] AND Bit1) SHL 2);
Dest[4, 7]	:= ((Src.Plane_0[4, 0] AND Bit0) SHR 0)		// line 4  pixel 7
		OR ((Src.Plane_0[4, 1] AND Bit0) SHL 1)
		OR ((Src.Plane_1[4, 0] AND Bit0) SHL 2)
		OR ((Src.Plane_1[4, 1] AND Bit0) SHL 3);

Dest[5, 0]	:= ((Src.Plane_0[5, 0] AND Bit7) SHR 7)		// line 5  pixel 0
		OR ((Src.Plane_0[5, 1] AND Bit7) SHR 6)
		OR ((Src.Plane_1[5, 0] AND Bit7) SHR 5)
		OR ((Src.Plane_1[5, 1] AND Bit7) SHR 4);
Dest[5, 1]	:= ((Src.Plane_0[5, 0] AND Bit6) SHR 6)		// line 5  pixel 1
		OR ((Src.Plane_0[5, 1] AND Bit6) SHR 5)
		OR ((Src.Plane_1[5, 0] AND Bit6) SHR 4)
		OR ((Src.Plane_1[5, 1] AND Bit6) SHR 3);
Dest[5, 2]	:= ((Src.Plane_0[5, 0] AND Bit5) SHR 5)		// line 5  pixel 2
		OR ((Src.Plane_0[5, 1] AND Bit5) SHR 4)
		OR ((Src.Plane_1[5, 0] AND Bit5) SHR 3)
		OR ((Src.Plane_1[5, 1] AND Bit5) SHR 2);
Dest[5, 3]	:= ((Src.Plane_0[5, 0] AND Bit4) SHR 4)		// line 5  pixel 3
		OR ((Src.Plane_0[5, 1] AND Bit4) SHR 3)
		OR ((Src.Plane_1[5, 0] AND Bit4) SHR 2)
		OR ((Src.Plane_1[5, 1] AND Bit4) SHR 1);
Dest[5, 4]	:= ((Src.Plane_0[5, 0] AND Bit3) SHR 3)		// line 5  pixel 4
		OR ((Src.Plane_0[5, 1] AND Bit3) SHR 2)
		OR ((Src.Plane_1[5, 0] AND Bit3) SHR 1)
		OR ((Src.Plane_1[5, 1] AND Bit3) SHR 0);
Dest[5, 5]	:= ((Src.Plane_0[5, 0] AND Bit2) SHR 2)		// line 5  pixel 5
		OR ((Src.Plane_0[5, 1] AND Bit2) SHR 1)
		OR ((Src.Plane_1[5, 0] AND Bit2) SHR 0)
		OR ((Src.Plane_1[5, 1] AND Bit2) SHL 1);
Dest[5, 6]	:= ((Src.Plane_0[5, 0] AND Bit1) SHR 1)		// line 5  pixel 6
		OR ((Src.Plane_0[5, 1] AND Bit1) SHR 0)
		OR ((Src.Plane_1[5, 0] AND Bit1) SHL 1)
		OR ((Src.Plane_1[5, 1] AND Bit1) SHL 2);
Dest[5, 7]	:= ((Src.Plane_0[5, 0] AND Bit0) SHR 0)		// line 5  pixel 7
		OR ((Src.Plane_0[5, 1] AND Bit0) SHL 1)
		OR ((Src.Plane_1[5, 0] AND Bit0) SHL 2)
		OR ((Src.Plane_1[5, 1] AND Bit0) SHL 3);

Dest[6, 0]	:= ((Src.Plane_0[6, 0] AND Bit7) SHR 7)		// line 6  pixel 0
		OR ((Src.Plane_0[6, 1] AND Bit7) SHR 6)
		OR ((Src.Plane_1[6, 0] AND Bit7) SHR 5)
		OR ((Src.Plane_1[6, 1] AND Bit7) SHR 4);
Dest[6, 1]	:= ((Src.Plane_0[6, 0] AND Bit6) SHR 6)		// line 6  pixel 1
		OR ((Src.Plane_0[6, 1] AND Bit6) SHR 5)
		OR ((Src.Plane_1[6, 0] AND Bit6) SHR 4)
		OR ((Src.Plane_1[6, 1] AND Bit6) SHR 3);
Dest[6, 2]	:= ((Src.Plane_0[6, 0] AND Bit5) SHR 5)		// line 6  pixel 2
		OR ((Src.Plane_0[6, 1] AND Bit5) SHR 4)
		OR ((Src.Plane_1[6, 0] AND Bit5) SHR 3)
		OR ((Src.Plane_1[6, 1] AND Bit5) SHR 2);
Dest[6, 3]	:= ((Src.Plane_0[6, 0] AND Bit4) SHR 4)		// line 6  pixel 3
		OR ((Src.Plane_0[6, 1] AND Bit4) SHR 3)
		OR ((Src.Plane_1[6, 0] AND Bit4) SHR 2)
		OR ((Src.Plane_1[6, 1] AND Bit4) SHR 1);
Dest[6, 4]	:= ((Src.Plane_0[6, 0] AND Bit3) SHR 3)		// line 6  pixel 4
		OR ((Src.Plane_0[6, 1] AND Bit3) SHR 2)
		OR ((Src.Plane_1[6, 0] AND Bit3) SHR 1)
		OR ((Src.Plane_1[6, 1] AND Bit3) SHR 0);
Dest[6, 5]	:= ((Src.Plane_0[6, 0] AND Bit2) SHR 2)		// line 6  pixel 5
		OR ((Src.Plane_0[6, 1] AND Bit2) SHR 1)
		OR ((Src.Plane_1[6, 0] AND Bit2) SHR 0)
		OR ((Src.Plane_1[6, 1] AND Bit2) SHL 1);
Dest[6, 6]	:= ((Src.Plane_0[6, 0] AND Bit1) SHR 1)		// line 6  pixel 6
		OR ((Src.Plane_0[6, 1] AND Bit1) SHR 0)
		OR ((Src.Plane_1[6, 0] AND Bit1) SHL 1)
		OR ((Src.Plane_1[6, 1] AND Bit1) SHL 2);
Dest[6, 7]	:= ((Src.Plane_0[6, 0] AND Bit0) SHR 0)		// line 6  pixel 7
		OR ((Src.Plane_0[6, 1] AND Bit0) SHL 1)
		OR ((Src.Plane_1[6, 0] AND Bit0) SHL 2)
		OR ((Src.Plane_1[6, 1] AND Bit0) SHL 3);

Dest[7, 0]	:= ((Src.Plane_0[7, 0] AND Bit7) SHR 7)		// line 7  pixel 0
		OR ((Src.Plane_0[7, 1] AND Bit7) SHR 6)
		OR ((Src.Plane_1[7, 0] AND Bit7) SHR 5)
		OR ((Src.Plane_1[7, 1] AND Bit7) SHR 4);
Dest[7, 1]	:= ((Src.Plane_0[7, 0] AND Bit6) SHR 6)		// line 7  pixel 1
		OR ((Src.Plane_0[7, 1] AND Bit6) SHR 5)
		OR ((Src.Plane_1[7, 0] AND Bit6) SHR 4)
		OR ((Src.Plane_1[7, 1] AND Bit6) SHR 3);
Dest[7, 2]	:= ((Src.Plane_0[7, 0] AND Bit5) SHR 5)		// line 7  pixel 2
		OR ((Src.Plane_0[7, 1] AND Bit5) SHR 4)
		OR ((Src.Plane_1[7, 0] AND Bit5) SHR 3)
		OR ((Src.Plane_1[7, 1] AND Bit5) SHR 2);
Dest[7, 3]	:= ((Src.Plane_0[7, 0] AND Bit4) SHR 4)		// line 7  pixel 3
		OR ((Src.Plane_0[7, 1] AND Bit4) SHR 3)
		OR ((Src.Plane_1[7, 0] AND Bit4) SHR 2)
		OR ((Src.Plane_1[7, 1] AND Bit4) SHR 1);
Dest[7, 4]	:= ((Src.Plane_0[7, 0] AND Bit3) SHR 3)		// line 7  pixel 4
		OR ((Src.Plane_0[7, 1] AND Bit3) SHR 2)
		OR ((Src.Plane_1[7, 0] AND Bit3) SHR 1)
		OR ((Src.Plane_1[7, 1] AND Bit3) SHR 0);
Dest[7, 5]	:= ((Src.Plane_0[7, 0] AND Bit2) SHR 2)		// line 7  pixel 5
		OR ((Src.Plane_0[7, 1] AND Bit2) SHR 1)
		OR ((Src.Plane_1[7, 0] AND Bit2) SHR 0)
		OR ((Src.Plane_1[7, 1] AND Bit2) SHL 1);
Dest[7, 6]	:= ((Src.Plane_0[7, 0] AND Bit1) SHR 1)		// line 7  pixel 6
		OR ((Src.Plane_0[7, 1] AND Bit1) SHR 0)
		OR ((Src.Plane_1[7, 0] AND Bit1) SHL 1)
		OR ((Src.Plane_1[7, 1] AND Bit1) SHL 2);
Dest[7, 7]	:= ((Src.Plane_0[7, 0] AND Bit0) SHR 0)		// line 7  pixel 7
		OR ((Src.Plane_0[7, 1] AND Bit0) SHL 1)
		OR ((Src.Plane_1[7, 0] AND Bit0) SHL 2)
		OR ((Src.Plane_1[7, 1] AND Bit0) SHL 3);

end;
