program	ReverseBits;


const	xRes		=	16;		LastX = xRes - 1;
	yRes		=	256 div xRes;	LastY = yRes - 1;

	Bit0		=	1 SHL 0;  Bits0 = Bit0 - 1;
	Bit1		=	1 SHL 1;  Bits1 = Bit1 - 1;
	Bit2		=	1 SHL 2;  Bits2 = Bit2 - 1;
	Bit3		=	1 SHL 3;  Bits3 = Bit3 - 1;
	Bit4		=	1 SHL 4;  Bits4 = Bit4 - 1;
	Bit5		=	1 SHL 5;  Bits5 = Bit5 - 1;
	Bit6		=	1 SHL 6;  Bits6 = Bit6 - 1;
	Bit7		=	1 SHL 7;  Bits7 = Bit7 - 1;

	Tab		=	#9;
	CRLF		=	#13#10;

	HexChars	:	array[$0..$F] of Char
			=	'0123456789ABCDEF';


var	DestFile	:	TextFile;


procedure Write(const Text : String);
begin
System.Write(DestFile, Text);
end;


function Byte2Hex(const Value : Byte) : String;
begin
Result := HexChars[Value SHR 4] + HexChars[Value AND Bits4];
end;


procedure Main;
var	i, x, y		:	Byte;
	Table		:	array[Byte] of Byte;
begin
for i := $00 to $FF do begin					// fill the table
	y := 0;
	for x := 0 to 7 do  y := y OR				// go through all bits
		(((i SHR x) AND Bit0) SHL (7 - x));		// get bit, insert it at new pos.
	Table[i] := y;
end;
i := 0;
for y := 0 to LastY do begin
	Write('  ');						// start of a line
	for x := 0 to LastX do begin				// write the values
		if (x <> 0) then Write(', ');			// separator
		Write('$' + Byte2Hex(Table[i]));		// value
		if (i <> $FF) then Inc(i);			// $FF will be last value of i
	end;
	if (y <> LastY) then Write(',' + CRLF);			// end of a line
end;
Write(CRLF);
end;


begin
AssignFile(DestFile, 'table.inc');
ReWrite(DestFile);
Main;
CloseFile(DestFile);
end.
